using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Deployment.Application;

namespace Deployment
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			PrintDeploymentInfo();

		}

		private void PrintDeploymentInfo()
		{
			if (ApplicationDeployment.IsNetworkDeployed)
			{
				label5.Text = "Yes";

				ApplicationDeployment currentDeployment = ApplicationDeployment.CurrentDeployment;
				DateTime lastCheck = currentDeployment.TimeOfLastUpdateCheck.ToLocalTime();
				String lastDay = lastCheck.Date.ToShortDateString();
				String lastTime = lastCheck.TimeOfDay.ToString();

				label6.Text = currentDeployment.CurrentVersion.ToString();
				label7.Text = currentDeployment.UpdatedVersion.ToString();
				label8.Text = String.Format("{0} at {1}", lastDay, lastTime);

			}
			else
			{
				label5.Text = "No";
				label6.Text = "N/A";
				label7.Text = "N/A";
				label8.Text = "N/A";
			}
		}

		private void Form1_Load(object sender, EventArgs e)
		{

		}

		private void button1_Click(object sender, EventArgs e)
		{
			if (ApplicationDeployment.IsNetworkDeployed)
			{
				ApplicationDeployment applicationDeployment = ApplicationDeployment.CurrentDeployment;
				label9.Text = "Checking for Update...";
				
				if(applicationDeployment.CheckForUpdate())
				{
					if (MessageBox.Show("Update Available! Install Now?", "Update Check Result", MessageBoxButtons.YesNo) == DialogResult.Yes)
					{
						UpdateCheckInfo updateCheckInfo = applicationDeployment.CheckForDetailedUpdate();

						label9.Text = "Update to version " + updateCheckInfo.AvailableVersion.ToString() + " of size " + updateCheckInfo.UpdateSizeBytes.ToString();

						applicationDeployment.Update();

						MessageBox.Show("This application will restart.");

						Application.Restart();

					}

					
					
				}


			}
			else
			{


			}

		}
	}
}